Attribute VB_Name = "modCPU"
'Generic CPU variables.
'Important to not mix them up.
Option Explicit

Public A As Byte, X As Byte, Y As Byte, P As Byte, S As Byte
Public PC As Long, help As Long, savepc As Long

Public Ticks As Long, CPU_Ticks As Long, TimerTicks As Long

Public opcode As Byte, temp As Byte, temp2 As Byte, temp3 As Byte

Public Stack(&HFF) As Byte

Public gameImage() As Byte

Public pow2(31) As Double

Public AddressingModes(&HFF) As Byte, Instructions(&HFF) As Byte, ClockTicks(&HFF) As Byte

Public PrevOp As Byte, PrevSavepc As Long
Public PrevAM As String, PrevOpcode As String, oMsg As String

Public AM(14) As String, Ins(68) As String, Adr2 As String, AdrMsg As String

Public CPURunning As Boolean, CPUPaused As Boolean

Public Const M6502_INTERNAL_REVISION As String = "M6502 CPU Emulator v0.11 Don Jarrett"
'M6502 Vectors
Public Const M6502NMI As Long = &HFFFA& 'Non-Maskable Interrupt
Public Const M6502RESET As Long = &HFFFC& 'Reset Vector
Public Const M6502IRQ As Long = &HFFFE& 'Interrupt ReQuest/BRK
'Addressing modes.
Public Const ADR_ERA As Long = 0  'ERROR!
Public Const ADR_ABS As Long = 1  'Absolute
Public Const ADR_ACC As Long = 2  'Accumulator, not sure..
Public Const ADR_IMP As Long = 3  'Implied
Public Const ADR_IMM As Long = 4  'Immediate
Public Const ADR_IND As Long = 5  'Indirect
Public Const ADR_INX As Long = 6  'Indexed X
Public Const ADR_INY As Long = 7  'Indexed Y
Public Const ADR_IZP As Long = 8  'Indirect ZP(65C02 only)
Public Const ADR_PII As Long = 9  'Pre-Indexed Indirect Y
Public Const ADR_PIX As Long = 10  'Pre-Indexed Indirect X
'Public Const ADR_REL As Long = 11  'Relative
Public Const ADR_ZP As Long = 12  'Zero-Page
Public Const ADR_ZPX As Long = 13  'Zero-Page X
Public Const ADR_ZPY As Long = 14  'Zero-Page Y
'Instructions
Public Const INS_ERA As Long = 0
Public Const INS_ADC As Long = 1
Public Const INS_AND As Long = 2
Public Const INS_ASL As Long = 3
Public Const INS_BBR As Long = 4
Public Const INS_BBS As Long = 5
Public Const INS_BCC As Long = 6
Public Const INS_BCS As Long = 7
Public Const INS_BEQ As Long = 8
Public Const INS_BIT As Long = 9
Public Const INS_BMI As Long = 10
Public Const INS_BNE As Long = 11
Public Const INS_BPL As Long = 12
Public Const INS_BRA As Long = 13
Public Const INS_BRK As Long = 14
Public Const INS_BVC As Long = 15
Public Const INS_BVS As Long = 16
Public Const INS_CLC As Long = 17
Public Const INS_CLD As Long = 18
Public Const INS_CLI As Long = 19
Public Const INS_CLV As Long = 20
Public Const INS_CMP As Long = 21
Public Const INS_CPX As Long = 22
Public Const INS_CPY As Long = 23
Public Const INS_DEA As Long = 24
Public Const INS_DEC As Long = 25
Public Const INS_DEX As Long = 26
Public Const INS_DEY As Long = 27
Public Const INS_EOR As Long = 28
Public Const INS_INA As Long = 29
Public Const INS_INC As Long = 30
Public Const INS_INX As Long = 31
Public Const INS_INY As Long = 32
Public Const INS_JMP As Long = 33
Public Const INS_JSR As Long = 34
Public Const INS_LDA As Long = 35
Public Const INS_LDX As Long = 36
Public Const INS_LDY As Long = 37
Public Const INS_LSR As Long = 38
Public Const INS_NOP As Long = 39
Public Const INS_ORA As Long = 40
Public Const INS_PHA As Long = 41
Public Const INS_PHP As Long = 42
Public Const INS_PHX As Long = 43
Public Const INS_PHY As Long = 44
Public Const INS_PLA As Long = 45
Public Const INS_PLP As Long = 46
Public Const INS_PLX As Long = 47
Public Const INS_PLY As Long = 48
Public Const INS_ROL As Long = 49
Public Const INS_ROR As Long = 50
Public Const INS_RTI As Long = 51
Public Const INS_RTS As Long = 52
Public Const INS_SBC As Long = 53
Public Const INS_SEC As Long = 54
Public Const INS_SED As Long = 55
Public Const INS_SEI As Long = 56
Public Const INS_STA As Long = 57
Public Const INS_STX As Long = 58
Public Const INS_STY As Long = 59
Public Const INS_STZ As Long = 60
Public Const INS_TAX As Long = 61
Public Const INS_TAY As Long = 62
Public Const INS_TRB As Long = 63
Public Const INS_TSB As Long = 64
Public Const INS_TSX As Long = 65
Public Const INS_TXA As Long = 66
Public Const INS_TXS As Long = 67
Public Const INS_TYA As Long = 68
'CPU types
Public CPU_TYPE As Byte
Public CPU_TYPES(&HFF) As String
'Actual CPU definitions. For convienence.
Public Const CPU_M6502 = 0 'NMOS 6502
Public Const CPU_M65C02 = 1 'CMOS 6502
Public Const CPU_M65SC02 = 2 'Centipede, Millipede, etc. CPU.
Public Const CPU_M6510 = 3 'Commdore 64 variation
Public Const CPU_M2A03 = 4 'NES's 6502

